
fLayer struct
	DC dword 0
	bmp dword 0
fLayer ends

.code 

MakeFont proc pointSize:DWORD,weight:DWORD,italic:DWORD,lpFontName:DWORD

    invoke GetDC, 0
    invoke GetDeviceCaps,eax,LOGPIXELSY
    mul pointSize
    xor edx, edx
    mov ecx, 72
    div ecx

    invoke CreateFont,eax,0,NULL,NULL,weight,italic,NULL,NULL,
                      DEFAULT_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,
                      PROOF_QUALITY,DEFAULT_PITCH or FF_DONTCARE,
                      lpFontName
    ret
MakeFont endp

fNewLayer proc uses esi lpLayerStruct:dword,_width:dword,height:dword
	
	mov esi,lpLayerStruct
	invoke CreateCompatibleDC,0
	.if eax==0
		invoke MessageBox,0,0,0,0
	.endif
	mov [esi].fLayer.DC,eax
;	invoke CreateIndependantBitmap,eax,_width,height
	mov [esi].fLayer.bmp,eax
	invoke SelectObject,[esi].fLayer.DC,[esi].fLayer.bmp
	invoke DeleteObject,eax
	
	
	ret
fNewLayer endp

fDeleteLayer proc uses esi lpLayerStruct:dword
	
	mov esi,lpLayerStruct
	invoke DeleteObject,[esi].fLayer.bmp
	invoke DeleteDC,[esi].fLayer.DC
	
	ret
fDeleteLayer endp

PERR	PROC uses ebx edi esi	;, _API : DWORD
LOCAL	szMsgBuf[500]:BYTE

	INVOKE GetLastError
	mov	ebx, eax
	INVOKE FormatMessage, \
		FORMAT_MESSAGE_FROM_SYSTEM,\
		NULL, \
		ebx, \					;Message Id
		LANG_NEUTRAL + SUBLANG_DEFAULT*1024, \	;Message language
		ADDR szMsgBuf, \			;Buffer to store message
		500, \					;Buffer size
		NULL					;No more arguments
	INVOKE	MessageBox, NULL, ADDR szMsgBuf, NULL, MB_OK

	;INVOKE	ExitProcess, -1

	ret

PERR	ENDP

fCenterWindows proc hWnd:dword,_width:dword,height:dword
	LOCAL xs,ys:dword
	LOCAL hxs,hys:dword
	
	invoke GetSystemMetrics,SM_CXSCREEN
	mov xs,eax
	shr eax,1
	mov hxs,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov ys,eax
	shr eax,1
	mov hys,eax
	
	mov eax,_width
	shr eax,1
	sub hxs,eax
	
	mov eax,height
	shr eax,1
	sub hys,eax
	
	invoke SetWindowPos,hWnd,HWND_NOTOPMOST,hxs,hys,_width,height,NULL
	
	ret
fCenterWindows endp


PushButton proc lpText:DWORD,hParent:DWORD,hIns:dword,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD


    invoke CreateWindowEx,0,
            CADD("BUTTON"),lpText,
            WS_CHILD or WS_VISIBLE,
            a,b,wd,ht,hParent,ID,
            hIns,NULL

    ret

PushButton endp


RichAppend proc hRWnd:dword,pBuff:DWORD,col:DWORD
    LOCAL charrng:CHARRANGE
    LOCAL charfmt:CHARFORMAT
    ; Tedd
    mov eax,-1
    mov charrng.cpMax,eax
    mov charrng.cpMin,eax
    mov charfmt.cbSize,SIZEOF CHARFORMAT
    mov charfmt.dwMask,CFM_COLOR
    mov eax,col
    mov charfmt.crTextColor,eax
    invoke SendMessage, hRWnd,EM_EXSETSEL,NULL,ADDR charrng
    invoke SendMessage, hRWnd,EM_SETCHARFORMAT,SCF_SELECTION,ADDR charfmt
    invoke SendMessage, hRWnd,EM_REPLACESEL,FALSE,pBuff
    invoke SendMessage, hRWnd,EM_SCROLLCARET,NULL,NULL      ;scroll the text into view
    ret
RichAppend endp

ucCatLen proc uses esi edi ebx lpDestination:dword,lpSource:dword,len:dword
	
	mov esi,lpSource
	mov edi,lpDestination
	invoke ucLen,lpDestination
	inc eax
	shl eax,1
	add edi,eax
	
	xor ecx,ecx
	back:
	mov ax,[esi+ecx]
	mov word ptr[edi+ecx],ax
	mov eax,len
	shl eax,1
	add ecx,2
	cmp ecx,eax
	jl back
	
	ret
ucCatLen endp