.586
.mmx
.xmm

.model flat,stdcall
option casemap:none

CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
    
   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include GDIPlus.inc
   Include masm32.inc
   include ucmacros.asm
   ;include graphics.inc
   include ffile.inc
   include hNullstring.inc
   include DataBase.inc
   ;include arabic_dict.inc
  ; include sapi_f.inc
   include fDataBase.inc
;	include Timers.asm

   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib msvcrt.lib
	;includelib Graphics.lib
	
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
TextBoxProc proto :DWORD,:DWORD,:DWORD,:DWORD

.data
	ClassName db "GEF",0
   	AppName  db "Farabi Arabic Dictionary",0

.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd	dword	?
	hEdit dword ?
	hEdit2 dword ?
	hEdit3 dword ?
	lb dword ?
	lbp dword ?
	tbp dword ?
	hBtn dword ?
	dllhnd dword 0
	hFont dword 0
	hDC dword 0
	fFile dword 0
	f_ind dword 0
	fDB fDataBFile <0>
	
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL e:TEXTRANGE
	LOCAL cntr:dword
	LOCAL tm,am:dword
	LOCAL fl,fsz,lc:dword
	LOCAL cr:CHARRANGE
	LOCAL hfile,off_d:dword
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED20.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif
		
		invoke GetWindowDC,hWnd
		mov hDC,eax
		
		mov   edx, WS_VSCROLL or WS_VISIBLE or \
              WS_BORDER or WS_CHILD or \
              LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or \
              LBS_DISABLENOSCROLL
	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("ListBox"),NULL,edx,0,100,450,150,hWnd,3,hInstance,NULL
	    mov   lb, eax
	    invoke MakeFont,11,FW_NORMAL,0,CADD("Courier New")
		invoke SendMessage,lb,WM_SETFONT,eax,TRUE
		
		invoke PushButton,CADD("Add"),hWnd,hInstance,450,100,100,30,1
		invoke PushButton,CADD("Delete"),hWnd,hInstance,450,130,100,30,2
		invoke PushButton,CADD("Save"),hWnd,hInstance,450,160,100,30,3
		
		
		invoke SetBkMode,hDC,TRANSPARENT
		invoke SelectObject,hDC,hFont
		invoke DeleteObject,eax
		invoke SetTextColor,hDC,0
		
;--------------------------------------------------------------------------------
; Example how to load a File
;
	invoke fDataBaseLoad,addr fDB,CADD("Test.fdb")
	.if eax==-1
		; This could mean that the file was not exist
		invoke MessageBox,0,CADD("Something went wrong"),0,0
;	.endif
	
;--------------------------------------------------------------------------------
		
		
		;invoke SetTimer,hWnd,0,100,addr Update
		
	    
		invoke fCenterWindows,hWnd,600,480
	.elseif uMsg==WM_COMMAND
;--------------------------------------------------------------------------------
;	Example How to Write, Add and Delete File	
		.if wParam==1
		
			invoke fDataBaseAdd,addr fDB,4,DATA_BINARY,CADD("Test")
		
		.elseif wParam==2
				invoke SendMessage,lb,LB_GETCURSEL,0,0
				push eax
				invoke SendMessage,lb,LB_DELETESTRING,eax,0
				pop eax
				inc eax
				invoke fDataBaseDelete,addr fDB,eax
		.elseif wParam==3
				invoke fDataBaseWrite,addr fDB,CADD("Test.fdb")
		.endif
;--------------------------------------------------------------------------------

	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp

TextBoxProc proc hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
	LOCAL lptext:dword
	LOCAL buff[256]:dword
	LOCAL hFile:dword 
	LOCAL nIndex:dword
	
	.if uMsg==WM_KEYUP
			
	.endif
	invoke CallWindowProc,tbp,hWnd,uMsg,wParam,lParam
	ret
TextBoxProc endp

end start